<?php

namespace App\Filament\Resources\Manage\Cooperations\Actions\Report;

use App\Enums\ApprovalStatus;
use App\Enums\CooperationStatus;
use App\Enums\RoleEnum;
use App\Filament\Resources\Manage\Cooperations\CooperationResource;
use App\Filament\Support\CheerfulNotification;
use App\Models\Report;
use App\Notifications\BroadcastNotification;
use Filament\Actions\Action;
use Filament\Support\Icons\Heroicon;

class AcceptAction extends Action
{
    protected function setUp(): void
    {
        parent::setUp();

        $this->label('Terima')
            ->icon(Heroicon::OutlinedCheck)
            ->color('success')
            ->action(function (Report $record): void {
                $record->update([
                    'status' => ApprovalStatus::ACCEPTED,
                ]);

                CheerfulNotification::success(
                    CheerfulNotification::getByKey('cooperation.report_approved_success'),
                    CheerfulNotification::getByKey('notification.report_approved_notice', ['record__title' => $record->title])
                )->send();

                $partnerUser = $record->mediaTaskAssignment?->partnerMedia?->company?->user;
                if ($partnerUser) {
                    $partnerUser->notify(new BroadcastNotification([
                        'title' => CheerfulNotification::getByKey('cooperation.report_cooperation_approved'),
                        'body' => CheerfulNotification::getByKey('notification.report_cooperation_approved', ['record__title' => $record->title, 'record__mediaTaskAssignment__taskAssignment__cooperation__title' => $record->mediaTaskAssignment->taskAssignment->cooperation->title]),
                        'action' => [
                            Action::make('view')
                                ->label('Lihat')
                                ->url(CooperationResource::getUrl('view', ['record' => $record->mediaTaskAssignment->taskAssignment->cooperation_id, 'relation' => 3])),
                        ],
                    ]));
                }
            })
            ->visible(
                fn (Report $record): bool => $record->mediaTaskAssignment?->taskAssignment?->cooperation?->status === CooperationStatus::VERIFICATION &&
                    ! auth()->user()->hasRole(RoleEnum::PERUSAHAAN->value) &&
                    $record->status === ApprovalStatus::PENDING
            );
    }
}
